# mypy-boto3-personalize

[![PyPI - mypy-boto3-personalize](https://img.shields.io/pypi/v/mypy-boto3-personalize.svg?color=blue)](https://pypi.org/project/mypy-boto3-personalize)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-personalize.svg?color=blue)](https://pypi.org/project/mypy-boto3-personalize)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-personalize](#mypy-boto3-personalize)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.Personalize 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/personalize.html#Personalize) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-personalize](#mypy-boto3-personalize)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Personalize` service.

```bash
python -m pip install boto3-stubs[personalize]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_personalize` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_personalize import PersonalizeClient

# Now mypy can check if your code is valid.
client: PersonalizeClient = boto3.client("personalize")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: PersonalizeClient = session.client("personalize")



# Annotated paginators are included as well

import mypy_boto3_personalize.paginator as personalize_paginators

list_batch_inference_jobs_paginator: personalize_paginators.ListBatchInferenceJobsPaginator = client.get_paginator("list_batch_inference_jobs")
list_campaigns_paginator: personalize_paginators.ListCampaignsPaginator = client.get_paginator("list_campaigns")
list_dataset_groups_paginator: personalize_paginators.ListDatasetGroupsPaginator = client.get_paginator("list_dataset_groups")
list_dataset_import_jobs_paginator: personalize_paginators.ListDatasetImportJobsPaginator = client.get_paginator("list_dataset_import_jobs")
list_datasets_paginator: personalize_paginators.ListDatasetsPaginator = client.get_paginator("list_datasets")
list_event_trackers_paginator: personalize_paginators.ListEventTrackersPaginator = client.get_paginator("list_event_trackers")
list_recipes_paginator: personalize_paginators.ListRecipesPaginator = client.get_paginator("list_recipes")
list_schemas_paginator: personalize_paginators.ListSchemasPaginator = client.get_paginator("list_schemas")
list_solution_versions_paginator: personalize_paginators.ListSolutionVersionsPaginator = client.get_paginator("list_solution_versions")
list_solutions_paginator: personalize_paginators.ListSolutionsPaginator = client.get_paginator("list_solutions")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_personalize` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_personalize as personalize
from mypy_boto3_personalize import PersonalizeClient

# with these
from mypy_boto3 import personalize
from mypy_boto3.personalize import PersonalizeClient
```